// BEGIN FLOCK GPL
// 
// Copyright Flock Inc. 2005-2007
// http://flock.com
// 
// This file may be used under the terms of of the
// GNU General Public License Version 2 or later (the "GPL"),
// http://www.gnu.org/licenses/gpl.html
// 
// Software distributed under the License is distributed on an "AS IS" basis,
// WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
// for the specific language governing rights and limitations under the
// License.
// 
// END FLOCK GPL
//


const BLOG_SRV = Components.classes['@flock.com/flock-blog;1'].getService(Components.interfaces.flockIBlogService);

/*
 * Coop stuff
 */

function loadSubScript(spec) {
  var loader = Components.classes['@mozilla.org/moz/jssubscript-loader;1']
     .getService(Components.interfaces.mozIJSSubScriptLoader);
  var context = {};
  loader.loadSubScript(spec, context);
  return context;
}

var Coop = loadSubScript('chrome://browser/content/flock/common/coop.js').Coop;

faves = Components.classes['@mozilla.org/rdf/datasource;1?name=flock-favorites'].getService(Components.interfaces.nsIRDFDataSource);
faves_coop = new Coop (faves, 'chrome://browser/content/flock/common/favorites-coop.js');


function onLoad() {
  var foldersPopup = $('foldersList');
  var enum_ = faves_coop.get("http://flock.com/rdf#DraftsRoot").children.enumerate();
  while (enum_.hasMoreElements()) {
    var folder = enum_.getNext();
    if (folder.id() != "http://flock.com/rdf#UnpublishedRoot") {
      var item = document.createElementNS("http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul", "menuitem");
      item.setAttribute("id", folder.id());
      item.setAttribute("label", folder.name);
      item.setAttribute("oncommand", "selectFolder('"+folder.id()+"');");
      foldersPopup.appendChild(item);
    }
  }
}


function selectFolder(aId) {
  var tree = document.getElementById('draftsTree');
  tree.setAttribute('ref', aId);
  tree.builder.rebuild();

  tree.selectedIndex = 0;
  previewPost(tree.selectedItem.getAttribute('postTitle'), tree.selectedItem.getAttribute('postContent'));
}


function previewPost(aTitle, aContent) {
  $('preview-frame').contentWindow.document.body.innerHTML = '<h1>'+aTitle+'</h1>'+aContent.replace(/(\r)?\n/gi, "<br/>");
  $('preview-deck').selectedIndex = 1;
}


function deleteSelected() {
  var item = $('draftsTree').selectedItem;

  if (!item)
    return;

  var prompts = Components.classes["@mozilla.org/embedcomp/prompt-service;1"]
                    .getService(Components.interfaces.nsIPromptService);
  if (prompts.confirm(window, "Delete Draft", "Really delete? It can not be undone."))
    BLOG_SRV.removeDraft(item.id);
}


function onAccept() { 
  // window.arguments[0].result = document.getElementById('draftsTree').selectedItem.id;
  var theId = document.getElementById('draftsTree').selectedItem.id;
  BLOG_SRV.openPost(theId);
  return true;
}

