// BEGIN FLOCK GPL
// 
// Copyright Flock Inc. 2005-2007
// http://flock.com
// 
// This file may be used under the terms of of the
// GNU General Public License Version 2 or later (the "GPL"),
// http://www.gnu.org/licenses/gpl.html
// 
// Software distributed under the License is distributed on an "AS IS" basis,
// WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
// for the specific language governing rights and limitations under the
// License.
// 
// END FLOCK GPL
//


const BLOG_SRV = Components.classes['@flock.com/flock-blog;1'].getService(Components.interfaces.flockIBlogService);

/*
 * Coop stuff
 */

var faves_coop = Components.classes['@flock.com/singleton;1'].getService(Components.interfaces.flockISingleton).getSingleton('chrome://browser/content/flock/common/load-faves-coop.js').wrappedJSObject;

function looseChanges() {
  var prompts = Components.classes["@mozilla.org/embedcomp/prompt-service;1"].getService(Components.interfaces.nsIPromptService);
  if (prompts.confirm(window, "Loose Recovery Data", "Are you sure you want to loose all your recovered drafts?")) {
    BLOG_SRV.looseRecovery();
    return true;
  }
  else
    return false;
}


function recover() {
  var posts = new Array();

  var recoveryRoot = faves_coop.get('http://flock.com/rdf#RecoveryRoot');
  var enum = recoveryRoot.children.enumerate();
  while (enum.hasMoreElements()) {
    var item = enum.getNext();
    posts.push({
      name: item.name,
      content: item.content,
      tags: item.tags,
    });
    recoveryRoot.children.remove(item);
    item.destroy();
  }

  // We need to loop again to open the blog editor with a clean recovery list
  // in coop -- otherwise, the recovery dialog appears again
  for (i=0; i<posts.length; i++)
    BLOG_SRV.openEditor(posts[i].name, posts[i].content, posts[i].tags);
  return true; 
}

