//
// BEGIN FLOCK GPL
// 
// Copyright Flock Inc. 2005-2007
// http://flock.com
// 
// This file may be used under the terms of of the
// GNU General Public License Version 2 or later (the "GPL"),
// http://www.gnu.org/licenses/gpl.html
// 
// Software distributed under the License is distributed on an "AS IS" basis,
// WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
// for the specific language governing rights and limitations under the
// License.
// 
// END FLOCK GPL
//


var mediabar = {
  _favsCoop : Components.classes['@flock.com/singleton;1']
                           .getService(Components.interfaces.flockISingleton)
                           .getSingleton('chrome://browser/content/flock/common/load-faves-coop.js')
                           .wrappedJSObject,
  load: function(aAccount) {
    mediabar.ensureOpen();
    var acctCoop = mediabar._favsCoop.get(aAccount.urn);
    if (acctCoop) {
      var serviceId = acctCoop.serviceId;
      if (serviceId && serviceId.length) {
        var svc = Components.classes[serviceId].getService(Components.interfaces.flockIMediaWebService);
        
        if (TopbarJSCtx().gPhotoDrawer) {
          TopbarJSCtx().gPhotoDrawer.loadPhotoPerson(aAccount.urn, svc.shortName);
        }
        else {
          TopbarJSCtx().initialMedia = { person: {
            urn: aAccount.urn,
            svc: svc.shortName
          }}
        }
      }
    }
  },
  loadQuery: function(aService, aQuery, aName) {
    mediabar.ensureOpen();
    if (TopbarJSCtx().gPhotoDrawer) {
      TopbarJSCtx().gPhotoDrawer.mFilter = '';
      TopbarJSCtx().gPhotoDrawer.loadQuery( aService, aQuery, aName );
      TopbarJSCtx().gPhotoDrawer.emptySearchbox();
    }
    else {
      TopbarJSCtx().initialMedia = { query: {
        service: aService,
        query: aQuery,
        name: aName
      }}
    }
  },
  loadFromId: function(aId) {
    mediabar.ensureOpen();
    if (TopbarJSCtx().gPhotoDrawer) {
      TopbarJSCtx().gPhotoDrawer.loadFromId( aId );
    }
    else {
      var item = mediabar._favsCoop.get(aId);
      TopbarJSCtx().initialMedia = { query: {
        service: item.service,
        query: item.query,
        name: item.name 
      }}
    }
  },
  showActionMessage: function(aMessage) {
    mediabar.ensureOpen();
    if (TopbarJSCtx().gPhotoDrawer) {
      TopbarJSCtx().gPhotoDrawer.showActionMessage(aMessage);
    }
  },
  hideActionMessage: function() {
    if (TopbarJSCtx().gPhotoDrawer) {
      TopbarJSCtx().gPhotoDrawer.hideActionMessage();
    }
  },
  lock: function()
  {
    mediabar.ensureOpen();
    var retval = true;
    if (TopbarJSCtx().gPhotoDrawer) {
      retval = TopbarJSCtx().gPhotoDrawer.lock();
    }
    return retval;
  },
  unlock: function()
  {
    
    if (TopbarJSCtx().gPhotoDrawer) 
    {
      TopbarJSCtx().gPhotoDrawer.unlock();
    }
  },
  ensureOpen: function() {
    flock_topbarSelectById('flock_MediabarTopbarBroadcaster', true)
  },
  
  needDiscovery: function(aService, aQuery)
  {
    var showDiscovery = true;
   // if the topbar is open with mediabar
    if ($("topbarBrowser").getAttribute("src") && TopbarJSCtx().gPhotoDrawer) {
      // don't show media discovery if mediabar already has owner's stream loaded
      if ( (TopbarJSCtx().gPhotoDrawer.mApi == aService) && (TopbarJSCtx().gPhotoDrawer.mQuery.stringVal == aQuery) ) {
        showDiscovery = false;
      }
    }
    return showDiscovery;
  }
};

var mediaOverlay = {
  mServiceMgr: null,
  _isFirstAuthForService: null,
  
  init: function() {
    this.mServiceMgr = Components.classes["@flock.com/webservice-manager;1"].getService(Components.interfaces.flockIWebServiceManager);
    this._isFirstAuthForService = false;
    this.mServiceMgr.addListener(this);
  },
  
  uninit: function() {
    this.mServiceMgr.removeListener(this);
  },
  
  onAccountCreated: function (aAccount, aDocument) {
    // is the new account a media service?
    if (aAccount instanceof Ci.flockIMediaWebServiceAccount) {
      //mediabar.load(aAccount);
      this._isFirstAuthForService = true;
    }
    
    // is the new account a ppl service?
    if (aAccount instanceof Ci.flockISocialWebServiceAccount) {
      // handle this with ppl overlay!!
    }
    
    // is the new account a blog service?
    if (aAccount instanceof Ci.flockIBlogWebServiceAccount) {
     // handle this in the blog overlay!
    }
    
    // is the new account a bookmarking service?
    if (aAccount instanceof Ci.flockIBookmarkWebService) {
      //handle this in the favorites overlay
    }
  },
  
  onAccountPasswordMissing: function (aDocument) {
  },

  onAccountRemoved: function (aAccount) {
  },
  
  onAccountAuthChange: function (aAccount) {
    if (aAccount instanceof Ci.flockIMediaWebServiceAccount) {
      if (this._isFirstAuthForService) {
        var wm = Cc["@mozilla.org/appshell/window-mediator;1"].getService(Ci.nsIWindowMediator);
        var win = wm.getMostRecentWindow('navigator:browser');
        if (win) {
          win.mediabar.load(aAccount);
        }
        this._isFirstAuthForService = false;
      }
    }
  }
}

window.addEventListener("load", function load() { mediaOverlay.init();}, false);
window.addEventListener("unload", function unload() {mediaOverlay.uninit();}, false);
