const Cc = Components.classes;
const Ci = Components.interfaces;
const Cr = Components.results;

var gMetrics = Cc["@flock.com/metrics-service;1"].getService(Ci.flockIMetricsService);

var _coop = Cc["@flock.com/singleton;1"]
  .getService(Ci.flockISingleton)
  .getSingleton("chrome://browser/content/flock/common/load-faves-coop.js")
  .wrappedJSObject;

const BLOG_SVC = Cc["@flock.com/flock-blog;1"].getService(Ci.flockIBlogService);

const PREFS = Cc["@mozilla.org/preferences-service;1"].getService(Ci.nsIPrefBranch);
const PREF_BROWSER_STARTUP_HOMEPAGE = "browser.startup.homepage";
const PREF_MYWORLD_CURRENT_ENGINE   = "flock.myworld.currentEngine";
const XMLHTTPREQUEST_CONTRACTID     = '@mozilla.org/xmlextras/xmlhttprequest;1'
const nsIXMLHttpRequest             = Components.interfaces.nsIXMLHttpRequest;

const nsIPrefLocalizedString = Components.interfaces.nsIPrefLocalizedString;

const RDFS = Cc["@mozilla.org/rdf/rdf-service;1"].getService(Ci.nsIRDFService);

function Namespace(ns) { return function (arg) { return RDFS.GetResource(ns+arg); } }
const FLRDF  = Namespace("http://flock.com/rdf#");
const NCRDF  = Namespace("http://home.netscape.com/NC-rdf#");

const myDays= ["Sunday","Monday","Tuesday","Wednesday","Thursday","Friday","Saturday","Sunday"];
const myMonths = ["January", 
                  "February",
                  "March",
                  "April",
                  "May",
                  "June",
                  "July",
                  "August",
                  "September",
                  "October",
                  "November",
                  "December"]

var rdfLiteral = RDFS.GetLiteral;

var currentEng;

window.addEventListener("resize", resizeFunc, false);

function resizeFunc(event) {
  doResize();
}

function enableDisableObservers(bValue) {
  if(bValue) {
    // Enable observers
    var rdfsService = RDFS.QueryInterface(Ci.nsIRDFService);
    this.dataSource = rdfsService.GetDataSource("rdf:flock-favorites");
  
    var observable = this.dataSource;
    observable.QueryInterface(Ci.flockIRDFObservable);
    observable.addArcObserver(Ci.flockIRDFObserver.WATCH_TYPES, null, FLRDF("photoid"), null, this._favObs);
    observable.addArcObserver(Ci.flockIRDFObserver.WATCH_TYPES, null, FLRDF("unseenItems"), null, this._favObs);
    observable.addArcObserver(Ci.flockIRDFObserver.WATCH_TYPES, null, NCRDF("bookmark"), null, this._favObs);
    observable.addArcObserver(Ci.flockIRDFObserver.WATCH_TYPES, null, NCRDF("isPollable"), null, this._favObs);
  } else {
    // Disable observers
    var observable = this.dataSource;
    observable.QueryInterface(Ci.flockIRDFObservable);
    observable.removeArcObserver(Ci.flockIRDFObserver.WATCH_TYPES, null, FLRDF("photoid"), null, this._favObs);
    observable.removeArcObserver(Ci.flockIRDFObserver.WATCH_TYPES, null, FLRDF("unseenItems"), null, this._favObs);
    observable.removeArcObserver(Ci.flockIRDFObserver.WATCH_TYPES, null, NCRDF("bookmark"), null, this._favObs);
    observable.removeArcObserver(Ci.flockIRDFObserver.WATCH_TYPES, null, NCRDF("isPollable"), null, this._favObs);
  } 
}

function onUnload() {
  var metrics = Components.classes['@flock.com/metrics-service;1']
    .getService(Components.interfaces.flockIMetricsService);
  metrics.reportCount('myworld close');

  var os = Cc["@mozilla.org/observer-service;1"].getService(Ci.nsIObserverService);
  os.removeObserver(this._obsObsrv, "browser-search-engine-modified");
  os.removeObserver(this._obsObsrv, "refresh-myworld");
  os.removeObserver(this._obsObsrv, "refresh-myworld-topsites");

  enableDisableObservers(false);
}
function onLoad()
{
  var metrics = Components.classes['@flock.com/metrics-service;1']
    .getService(Components.interfaces.flockIMetricsService);
  metrics.reportCount('myworld open');

  doResize();
  
  checkDefaultHomepage();  
  
  loadEngines();

  refreshAccounts();
  refreshDateTime();
 
  // delay load
  setTimeout("this.refreshFeeds()",100);

  // Add observer for refresh
  var inst = this;
  this._favObs = {};
  this._favObs.rdfChanged = function (ds, type, source, predicate, target, oldtarget) {
    if (!source) return;
   
    var coopObj = inst._coop.get_from_resource(source);
    if (!coopObj) return;

    if(coopObj.flockType == "media") {
      if (document.getElementById(coopObj.id())) {
        dump("JMC: Gonna force rebuild of mediaquery: " + coopObj.id() + +"\n");
        document.getElementById(coopObj.id()).forceRebuild();
        // early exit, don't resize since we still have the same amount of content.
        return;
      }
    } else if (coopObj.flockType == "feed"){
      setTimeout("refreshFeeds()",500);
    } else if(coopObj.flockType == "bookmark" && coopObj.photoid) {  
      // early exit, don't resize since we still have the same amount of content.
      return;
      // setTimeout("refreshMedia()", 500);
    }
    
    inst.doResize();
  }
  
  this._obsObsrv = {};
  this._obsObsrv.observe = function engineManager_observer(aEngine, aTopic, aVerb) {
    if(aTopic == "browser-search-engine-modified") {
      aEngine.QueryInterface(Ci.nsISearchEngine);
      switch( aVerb) {
        case "engine-added":
        case "engine-removed":
          loadEngines();
      }
    } else if (aTopic == "refresh-myworld") {
      setTimeout("refreshMedia()",500); 
    } else if (aTopic == "refresh-myworld-topsites") {
      setTimeout("decorateTopSites()", 500);
    }
  }
  // Add observer for engines added
  var os = Cc["@mozilla.org/observer-service;1"].getService(Ci.nsIObserverService);
  os.addObserver(this._obsObsrv, "browser-search-engine-modified", false);
  os.addObserver(this._obsObsrv, "refresh-myworld", false);
  os.addObserver(this._obsObsrv, "refresh-myworld-topsites", false);
  
  setTimeout("decorateTopSites()", 500);

  enableDisableObservers(true);
}

function decorateTopSites() {
  // Simply go through the entire topsites setting odd/even styling.
  var topSites = document.getElementById("faveContent");
  
  var children = topSites.childNodes;
  for(var i=1;i<children.length;i++) {
    var topsite = children[i];
    if(i % 2) {
      topsite.setAttribute("class", "faveSite"); 
    } else {
      topsite.setAttribute("class", "faveSiteOdd"); 
    }
  }
}

function doResize() {

  theHeight = window.innerHeight - 350;
  if(theHeight < 290)
    theHeight = 290;

  var ftc = document.getElementById("ftcontainerID");
  var fc = document.getElementById("faveContent");
  var fb = document.getElementById("feedBoxContents");
  var mb = document.getElementById("mediaBoxContents");
  
  var oldfcHeight = fc.getAttribute("height");
  var oldfbHeight = fb.getAttribute("height");
  var oldmbHeight = mb.getAttribute("height");
  
  if(oldfcHeight != theHeight
      || oldfbHeight != theHeight
      || oldmbHeight != theHeight) {
    fc.setAttribute("height", theHeight + "px");
    fb.setAttribute("height", theHeight + "px");
    mb.setAttribute("height", theHeight + "px");
  }
}

function checkDefaultHomepage() {
   var defhbox = document.getElementById("makedefault");
   
   // Remove to re-build
   while(defhbox.firstChild) {
      defhbox.removeChild(defhbox.firstChild); 
   }
   
   // check if flock is in the default
   if(PREFS.getPrefType(PREF_BROWSER_STARTUP_HOMEPAGE)) {
      var homepage = PREFS.getComplexValue(PREF_BROWSER_STARTUP_HOMEPAGE, nsIPrefLocalizedString).data;
      if(homepage.indexOf("about:myworld") >= 0) {
        return; 
      }
   }
   
   // Add to page if nescessary
   var button = document.createElement("button");
   button.setAttribute("onclick", "makeDefaultHomepage()");
   button.setAttribute("class", "defaultHomepageBtn");
   
   var label = document.createElement("label");
   label.setAttribute("class", "myworldHomepage");
   label.setAttribute("value", "Set as default homepage");
   
   button.appendChild(label);
   defhbox.appendChild(button);
}

function loadEngines() {
  // Get a list of all search engines
  var searchService = Cc["@mozilla.org/browser/search-service;1"].getService(Ci.nsIBrowserSearchService);

  var engines = searchService.getVisibleEngines({ });

  const kXULNS = "http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul";
  var eMenu = document.getElementById("engineMenuID");

  // delete list before re-creating it
  var existingChildrenCount = eMenu.childNodes.length;
  for(var z=existingChildrenCount;z>0;z--)
  {
    var existChild = eMenu.childNodes[z-1];
    eMenu.removeChild(existChild);
  }

  var currentEngine;
  // Get current myworld engine
  if(PREFS.getPrefType(PREF_MYWORLD_CURRENT_ENGINE)) {
    currentEngine = PREFS.getCharPref(PREF_MYWORLD_CURRENT_ENGINE);
  } else {
    // If myworld engine doesnt exist, use current default engine
    currentEngine = searchService.currentEngine.name;
  }

  PREFS.setCharPref(PREF_MYWORLD_CURRENT_ENGINE, currentEngine);
  
    // Add them to the menu
  for(var i=engines.length-1;i>=0;--i) {
    var menuitem = document.createElementNS(kXULNS, "menuitem");
    menuitem.setAttribute("label", engines[i].name);
    menuitem.setAttribute("id", engines[i].name);
    menuitem.setAttribute("class", "engine-menuitem");
    menuitem.setAttribute("engine", engines[i].name);
    menuitem.setAttribute("image", engines[i].iconURI);
    menuitem.setAttribute("oncommand", "selectEngine(this)");

    if(engines[i].name == currentEngine) {
      menuitem.setAttribute("selected", "true");
      currentEng = engines[i];
    }

    if(engines[i].iconURI) {
      menuitem.setAttribute("image", engines[i].iconURI.spec);

      // Also set the image of the selected item
      if(engines[i].name == currentEngine) {
        var engineImageID = document.getElementById("engineImageID");
        engineImageID.setAttribute("src",engines[i].iconURI.spec);
      }
    }

    eMenu.insertBefore(menuitem, eMenu.firstChild);
    menuitem.engine = engines[i];
  }
}

function toggleEngineMenu() {
  var popup = document.getElementById("engineMenuID");
  var popButton = document.getElementById("popButton");

  popup.showPopup(popButton, -1, -1, "popup", "bottomleft", "topleft");
}

function selectEngine(engine) {
  var engineName  = engine.getAttribute("engine");
  var engineImage = engine.getAttribute("image");
  gMetrics.reportCount("myworld select search "+engineName);

  if(engineImage != "" && engineImage != null) {
    var engineImageID = document.getElementById("engineImageID");
    engineImageID.setAttribute("src",engineImage);
  }

  // Set current engine
  var searchService = Cc["@mozilla.org/browser/search-service;1"].getService(Ci.nsIBrowserSearchService);
  var engines = searchService.getVisibleEngines({ });

  for(var i=engines.length-1;i>=0;--i) {
    if(engines[i].name == engineName) {
      currentEng = engines[i];
      PREFS.setCharPref(PREF_MYWORLD_CURRENT_ENGINE, currentEng.name);
      return;
    }
  }
}

function refreshFeeds() {

  var feedBox = document.getElementById("feedBoxContents");

  var feedCount = feedBox.childNodes.length;
  
  // Don't count the template
  var count = 2;
  var bAtLeastOneHeadlineShowing = false;

  while (count < feedCount) {
    var feed = feedBox.childNodes[count];
    
    if(count % 2) {
      feed.setAttribute("class", "faveFeedOdd"); 
    } else {
      feed.setAttribute("class", "faveFeedSite"); 
    }
    
    // Get headlines
    var headlinesArr = getFeedHeadlines(feed);

    // Update the friendly date
    var headlinesNode = feed.firstChild.childNodes[1].childNodes[1].childNodes[1];

    // Remove old headlines
    while(headlinesNode.firstChild) {
      headlinesNode.removeChild(headlinesNode.firstChild);
    }

    for(var z=0;z<headlinesArr.length;z++) {
      var headlineText = document.createElement("label");
      headlineText.setAttribute("value", headlinesArr[z][0]);
      headlineText.setAttribute("onclick", "openFeedHeadline('" + headlinesArr[z][1] + "','" + headlinesArr[z][2] + "', event)");
      headlineText.setAttribute("class", "headlinesItem");
      headlinesNode.appendChild(headlineText);
    }

    // update the unseen items
    var unseenItems = feed.firstChild.firstChild.firstChild;
    var usic = unseenItems.getAttribute("feedUnseen");
    var feedLastUpdated = unseenItems.getAttribute("feedLastUpdated");
    var friendlyDate    = getFriendlyLastDate(feedLastUpdated);

    unseenItems.setAttribute("value",usic + " new!");
    var unseenItemsTime = feed.firstChild.firstChild.childNodes[1];
    unseenItemsTime.setAttribute("value", friendlyDate);
    
    if(usic == 0) {
      feed.setAttribute("hidden", "true");
    } else {
      bAtLeastOneHeadlineShowing = true;
      feed.setAttribute("hidden", "false");
    }

    count++;
  }

  var unreadMsg = document.getElementById("unreadID");
  if(bAtLeastOneHeadlineShowing) {
    // don't show the unread msg
    unreadMsg.setAttribute("hidden", "true");
  } else {
    unreadMsg.setAttribute("hidden", "false");
  }
  
  refreshDateTime();
}

function openFeedHeadline(headlineURL, headlineID, event) {
  if(event.button == 2) {
    return;
  }

  gMetrics.reportCount("myworld feed headline click");
  var wm = Cc["@mozilla.org/appshell/window-mediator;1"].getService(Ci.nsIWindowMediator);
  var win = wm.getMostRecentWindow('navigator:browser');
  if (win) {
    win.newsSidebarOpen();
    
    openURLMyWorld(headlineURL,event);
    
    var coopObj = _coop.get(headlineID);
    coopObj.unseen = false;
  }

}

function populateTooltip(node) {

  var headlines = node.getAttribute("headlines");
  var headlinesArr = headlines.split("|||");

  var tipContainer = document.getElementById("tipcontainer");

  while(tipContainer.firstChild) {
    tipContainer.removeChild(tipContainer.firstChild);
  }

  for(var i=0;i<headlinesArr.length;i++) {
    var headline = headlinesArr[i];

    var label = document.createElement("label");
    label.setAttribute("value", headline);

    tipContainer.appendChild(label);
  }
}

function getFeedHeadlines(feed) {
  var headlines = [];

  var childrenCount = feed.childNodes.length;

  var z=0;

  for(var i=childrenCount;i> 0;i--) {

    if(i < 2)
      return headlines;
      
    // Only record unread headlines
    var coopObj = _coop.get(feed.childNodes[i-1].id);
    if(coopObj && !coopObj.unseen)
      continue;

    headlines[z]    = [];
    headlines[z][0] = feed.childNodes[i-1].firstChild.getAttribute("feedDescription");
    headlines[z][1] = feed.childNodes[i-1].firstChild.getAttribute("headlineURL");
    headlines[z][2] = feed.childNodes[i-1].id;

    // return a maximum of 3 headlines
    if(z++ == 2)
      return headlines;
  }

  return headlines;
}

function refreshMedia() {
  
  var mediaQueries = document.getElementsByTagName("mediaquery");
  for (var i=0; i < mediaQueries.length; i++) {
    mediaQueries[i].forceRebuild();
  }
}

function setOpacity(node, opacityNum) {
  node.style.opacity = opacityNum;
}

function refreshAccounts()
{
  var bFoundAvatar = false;

  var catMgr = Cc["@mozilla.org/categorymanager;1"].getService(Ci.nsICategoryManager);
  var e = catMgr.enumerateCategory("flockWebService");
  var serviceBox = document.getElementById("availableServices");
  var svcChild = serviceBox.firstChild;
  while (svcChild) {
    serviceBox.removeChild(svcChild);
    svcChild = serviceBox.firstChild;
  }
  var foundAccounts = false;
  while (e.hasMoreElements()) {
    var entry = e.getNext().QueryInterface(Ci.nsISupportsCString);
    if (!entry) continue;
    var contractID = catMgr.getCategoryEntry("flockWebService", entry.data);
    var svc = Cc[contractID].getService(Ci.flockIWebService);
    if (svcHasAccounts(svc)) {

      // Set Avatar - pick the very first valid loc that we can find
      if (!bFoundAvatar) {
        var avatarImg = document.getElementById("avatarImgId");

        // remove old avatar if it's there
        var oldAvatarImg = avatarImg.firstChild;
        while(oldAvatarImg) {
          avatarImg.removeChild(oldAvatarImg);
          oldAvatarImg = avatarImg.firstChild;
        }

        // Get avatar img location
        var imgLoc = getAvatarImgSrc(svc);
        if(imgLoc != ""
           && imgLoc != null) {
          // Set new avatar
          var img = document.createElement("image");
          img.setAttribute("src", imgLoc );
          avatarImg.appendChild(img);

          bFoundAvatar = true;
        }
      }

      foundAccounts = true;
    } else {
      var stack = document.createElement("stack");
      /* BC: We're just using css to create this bg for now, may change later so keep this code.
      var bg = document.createElement("image");
      bg.setAttribute("src", "chrome://browser/skin/myworld/favicon-border.png");
      stack.appendChild(bg);
      */
      stack.setAttribute("class","favStack");
      var fg = document.createElement("image");
      fg.setAttribute("src", svc.icon);
      fg.setAttribute("urn", svc.urn);
      fg.setAttribute("top", "1");
      fg.setAttribute("left", "1");
      fg.setAttribute("serviceName", svc.shortName); // XXX
      fg.setAttribute("tooltiptext", svc.title);
      fg.setAttribute("onclick", "openService(this, event)");
      fg.setAttribute("class", "accountIcon");
      stack.appendChild(fg);
      serviceBox.appendChild(stack);
    }
  }
  var accountsArea = document.getElementById("configuredAccounts");
  var avatarContainer = document.getElementById("avatarContainer");
  
  if(bFoundAvatar) {
    avatarContainer.removeAttribute("hidden");
  } else {
    avatarContainer.setAttribute("hidden", "true");
  }
  
  if (foundAccounts) {
    accountsArea.removeAttribute("hidden");
  } else {
    accountsArea.setAttribute("hidden", "true");
  }
}

function getUpdatedDate(lastUpdated) {
  var date = lastUpdated.split(" ")[0];

  var m = date.split("/")[1];
  var d = date.split("/")[0];
  var y = date.split("/")[2];

  date = new Date(lastUpdated);
  var datenow = new Date();

//@line 561 "/home/build/tinderbuild_blue/src/flock/mozilla/browser/components/flock/start/content/myworld.js"
  // Do nothing
//@line 563 "/home/build/tinderbuild_blue/src/flock/mozilla/browser/components/flock/start/content/myworld.js"

  var updatedDate = datenow.getTime() - date.getTime();

  return updatedDate;
}

function getFriendlyLastDate(lastUpdated) {
  var updatedDate = getUpdatedDate(lastUpdated);

  var minutesSince = ((updatedDate/1000) / 60);
  var hoursSince = ((updatedDate/1000) / 60) / 60;
  var daysSince = ((updatedDate/1000) / 60) / 60 / 24;
  
  if(daysSince >= 2.0) {
    return daysSince.toFixed(0) + " days ago";
  } else if (daysSince >= 1.0) {
    return 1 + " day ago";
  } else if (hoursSince >= 2.0){
    return hoursSince.toFixed(0) + " hrs ago";
  } else if (hoursSince >= 1.0){
    return 1 + " hr ago";
  } else if (minutesSince >= 2.0) {
    return minutesSince.toFixed(0) + " mins ago";
  }

  return "A moment ago";
}

function openService(node, event)
{
  if(event.button == 2) {
    return;
  }

  // Open the service URL in a new tab
  var svcName = node.getAttribute("serviceName");
  gMetrics.reportCount("myworld service click "+svcName);
  var wm = Cc["@mozilla.org/appshell/window-mediator;1"].getService(Ci.nsIWindowMediator);
  var win = wm.getMostRecentWindow('navigator:browser');
  if (win) {
    win.openUILinkIn("http://redir.flock.com/redir?component=browser&action=myworld_click&partner=" + svcName, "tab");
  }

  // Tell the Web Service Manager to automatically keep any accounts
  // created for this service in the next while...
  var wsm = Cc["@flock.com/webservice-manager;1"].getService(Ci.flockIWebServiceManager);
  wsm.autoKeepAccountForService(node.getAttribute("urn"));
}

function getAvatarImgSrc(svc) {
  var accounts = svc.getAccounts();
  if (!accounts) return "";
  accounts.QueryInterface(Ci.nsISimpleEnumerator);

  while (accounts.hasMoreElements()) {
    var account = accounts.getNext();

    account.QueryInterface(Ci.flockIWebServiceAccount);

    var faves_coop = Cc['@flock.com/singleton;1'].getService(Ci.flockISingleton).getSingleton('chrome://browser/content/flock/common/load-faves-coop.js').wrappedJSObject;

    var acc = faves_coop.get(account.urn);

    if(acc) {
      return acc.avatar;
    }
  }

  return "";
}

function refreshDateTime()
{
  var timeLabel = document.getElementById("timeUpdated");
  var dateLabel = document.getElementById("dateUpdated");
  var time = new Date();
  var hours = time.getHours();
  var mins = time.getMinutes();
  if (mins < 10) mins = "0"+mins;
  var ampm = "am";
  if (hours >= 12) {
    ampm = "pm";
    if (hours > 12) hours -= 12;
  }
  
  var thedate = myDays[time.getDay()] + ", " + myMonths[time.getMonth()] + " " + time.getDate() + ", " + time.getFullYear();
  
  var timeString = hours+":"+mins+ampm;
  timeLabel.setAttribute("value", timeString);
  dateLabel.setAttribute("value", thedate);
}

function svcHasAccounts(svc)
{
  svc.QueryInterface(Ci.flockIWebService);
  var accounts = svc.getAccounts();
  if (!accounts) return false;
  accounts.QueryInterface(Ci.nsISimpleEnumerator);
  return accounts.hasMoreElements();
}

function reloadMyWorld() {
  // XXX: unfortunately the template does not re-sort the list until a page reload occurrs.
  var wm = Cc["@mozilla.org/appshell/window-mediator;1"].getService(Ci.nsIWindowMediator);
  var win = wm.getMostRecentWindow('navigator:browser');
  if (win) {
    var gBrowser = win.gBrowser;
    
    for(var i=0;i<gBrowser.mTabs.length;i++) {
      var browser = gBrowser.mTabs[i].linkedBrowser;
       if(browser.currentURI.spec == "about:myworld") {
         browser.reload();
       }
    }
  }
}

function refreshMyWorld()
{
  // force redraw of template area.
  var box = document.getElementById("mediaBoxContents");
  box.builder.rebuild();
  
  refreshDateTime();
}

function uploadPhotos(event)
{
  if(event.button == 2) {
    return; 
  }
  
  gMetrics.reportCount("myworld open uploader");
  var wm = Cc["@mozilla.org/appshell/window-mediator;1"].getService(Ci.nsIWindowMediator);
  var win = wm.getMostRecentWindow('navigator:browser');
  if (win) {
    win.flock_photo.util.launchUploader();
  }
}

function createBlogPost(event)
{
  if(event.button == 2) {
    return; 
  }
  
  gMetrics.reportCount("myworld open blogpost");
  BLOG_SVC.openEditor("","","");
}

function searchboxKeyPress(event,query) {
  if (event.keyCode == KeyEvent.DOM_VK_RETURN) {
    searchFunction(query);
  }
}

function searchFunction(query)
{
  var wm = Cc["@mozilla.org/appshell/window-mediator;1"].getService(Ci.nsIWindowMediator);
  var win = wm.getMostRecentWindow('navigator:browser');
  if (win) {
    var ss = Cc["@mozilla.org/browser/search-service;1"].getService(Ci.nsIBrowserSearchService);
    var submission = currentEng.getSubmission(query, null); // HTML response
    if (!submission) { return; }

    gMetrics.reportCount("myworld search "+currentEng.name);
    var submissionURL = tweakAffiliateCode(submission.uri);
    win.openUILinkIn(submissionURL, "tab");
  }
}

function tweakAffiliateCode(aSearchURI)
{
  var spec = aSearchURI.spec;
  // If this is a Yahoo! search, we want to tweak the affiliate search code so
  // we know that this search is being done from My World
  if (aSearchURI.host == "search.yahoo.com") {
    // This particular regex trick relies on the fact that My World types are
    // the same as the chrome types, except My World types have a "w" appended
    // to the type's letters.  (ex: fl09 becomes flw09)
    spec = spec.replace(/&type=([a-z]+)?09/, "&type=$1w09");
  }
  return spec;
}

function openWebClipboard(event) {
  if(event.button == 2) {
    return; 
  }  
  
  var wm = Cc["@mozilla.org/appshell/window-mediator;1"].getService(Ci.nsIWindowMediator);
  var win = wm.getMostRecentWindow('navigator:browser');
  if (win) {
    // Only open, don't close if already open
    win.toggleSidebar("flock_notesSidebarBroadcaster", true);
  }
}

function openAASSidebar(node, event)
{
  if(event.button == 2) {
    return;
  }
  
  if(node == null) {
    // Just open the sidebar.
    var wm = Cc["@mozilla.org/appshell/window-mediator;1"].getService(Ci.nsIWindowMediator);
    var win = wm.getMostRecentWindow('navigator:browser');
    if (win) {
      gMetrics.reportCount("myworld accounts");
      // Only open, don't close if already open
      win.toggleSidebar("flock_AccountsSidebarBroadcaster", true);
    }
    
    return; 
  }
 
  var homeURL = node.getAttribute("homeURL");
  openURLMyWorld(homeURL, event);
}

function openFavoritesManager(event)
{
  if(event.button == 2) {
    return;
  }

  var wm = Cc["@mozilla.org/appshell/window-mediator;1"].getService(Ci.nsIWindowMediator);
  var win = wm.getMostRecentWindow('navigator:browser');
  if (win) {
    // Only open, don't close if already open
    win.toggleSidebar("viewBookmarksSidebar", true);
  }
}

function openNewsSidebar(node, event)
{
  if(event.button == 2) {
    return;
  }
 
  var wm = Cc["@mozilla.org/appshell/window-mediator;1"].getService(Ci.nsIWindowMediator);
  var win = wm.getMostRecentWindow('navigator:browser');
  if (win) {
    win.newsSidebarOpen();

    if(node != null) {
      gMetrics.reportCount("myworld view feed");
      var url = node.getAttribute("url");
      openURLMyWorld("flock://favorites/urn:flock:feed:" + url,event);
    }
  }
}


function openImage(node, event) {
  if(event.button == 2) {
    return;
  }
 
  gMetrics.reportCount("myworld photo click");
  var imageURL = node.getAttribute("imageURL");
  
  openURLMyWorld(imageURL, event);

  // Open the media bar
  var dataNode = node.parentNode.parentNode.parentNode.parentNode;
  openMediaBar(dataNode, event);   
}

function openMediaBar(node, event)
{
  if(event.button == 2) {
    return;
  }
  
  gMetrics.reportCount("myworld view mediastream");
  var service = node.getAttribute("svc");
  var query   = node.getAttribute("query");
  var name    = node.getAttribute("name");

  var wm = Cc["@mozilla.org/appshell/window-mediator;1"].getService(Ci.nsIWindowMediator);
  var win = wm.getMostRecentWindow('navigator:browser');
  if (win) {
    win.flock_topbarSelectById('flock_MediabarTopbarBroadcaster',true);
    
    if(service != "") {
      win.mediabar.loadQuery(service,query,name);
    }
  }
}

function openURL(node, event)
{
  if(event.button == 2) {
    return;
  }
 
  var url = node.childNodes[1].childNodes[1].value;
  gMetrics.reportCount("myworld fave click");

  // Open in new tab
  openURLMyWorld(url, event);
}

function popupWhatsThis(node) {
  var description   = node.getAttribute("desc");
  var descriptionID = node.getAttribute("descID");

  var popup = document.getElementById(descriptionID);

  while(popup.firstChild) {
    popup.removeChild(popup.firstChild);
  }

  var descNode = document.createElement("description");
  descNode.setAttribute("class", "whatsThisPopup");
  descNode.setAttribute("flex", "1");
  var text = document.createTextNode(description);
  descNode.appendChild(text);
  popup.appendChild(descNode);

  popup.showPopup(node, -1, -1, "popup", "bottomleft", "topleft");
}

function makeDefaultHomepage() {
  // Make My World the default homepage
  PREFS.setCharPref(PREF_BROWSER_STARTUP_HOMEPAGE, "about:myworld");
  
  checkDefaultHomepage();
 
  var notificationBox = getNotificationBox(); 
  if(notificationBox) {
    var message = "Your homepage has been set to My World";
    notificationBox.appendNotification( message,
                                        "myworldadded",
                                        "chrome://browser/skin/Info.png", 
                                        notificationBox.FLOCK_PRIORITY_MEDIUM,
                                        null,
                                        null);
  
  }
}

function getNotificationBox() {
  
  var wm = Cc["@mozilla.org/appshell/window-mediator;1"].getService(Ci.nsIWindowMediator);
  var win = wm.getMostRecentWindow('navigator:browser');
  if (win) {
    var gBrowser = win.getBrowser();
    var notificationBox = gBrowser.getNotificationBox();                                     
    
    return notificationBox;
  } 
  
  return null;
}

function openURLMyWorld(url, event) {
  
  if(event.button == 2) {
    return;
  }
  
  var wm = Cc["@mozilla.org/appshell/window-mediator;1"].getService(Ci.nsIWindowMediator);
  var win = wm.getMostRecentWindow('navigator:browser');
  if (win) {
    if(event.metaKey || event.ctrlKey || event.button == 1) {
      // opens url in new tab in the background - allows you to "queue" up tabs for viewing
      var gBrowser = win.getBrowser();
      gBrowser.addTab(url, null, null, null, null, null);
    } else {
      // opens url in new tab and switches to it immediately
      win.openUILinkIn(url,"tab");
    } 
  }
}

window.onload = onLoad;
window.onunload = onUnload;
