//
// BEGIN FLOCK GPL
// 
// Copyright Flock Inc. 2005-2007
// http://flock.com
// 
// This file may be used under the terms of of the
// GNU General Public License Version 2 or later (the "GPL"),
// http://www.gnu.org/licenses/gpl.html
// 
// Software distributed under the License is distributed on an "AS IS" basis,
// WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
// for the specific language governing rights and limitations under the
// License.
// 
// END FLOCK GPL
//

var $ = function (x) { return document.getElementById(x); };
var FLOCK_NS = "http://flock.com/rdf#";

var faves_coop = peopleUtils.faves_coop;

function onLoad () {
  var imgElement = $('meAvatar');
  imgElement.src = getMyAvatar();
  imgElement.setAttribute('src', getMyAvatar());
  
  populateNotifications($('notificationPane'));
  populateMedia($('mediaPaneContent'));
  populateFlock($('flockPaneContent'));
  
}

function openSearch() {
  openUILinkIn('http://search.yahoo.com/search?fr=flk&ei=UTF-8&p=' + $('searchWidget').value, "current");  
}

function getMyAvatar() {
 var accountsEnum = peopleUtils.faves_coop.get("http://flock.com/rdf#AccountsRoot").children.enumerate(); 
 while (accountsEnum.hasMoreElements()) {
   var account = accountsEnum.getNext();
   if (account.avatar && account.avatar != 'undefined')
     return account.avatar;
 }
 return "http://spread.flock.com/buttons/Be-a-Flockstar.png";
}

var identities = {};
function populateNotifications(aElement) {
  identities = {};
  var accountRoot = faves_coop.get("http://flock.com/rdf#AccountsRoot");
  var myFilter = {notify: true };
  var notifyEnum = aggregateStreams(getContainedItems(accountRoot, identities, myFilter));
  populateElement(aElement, notifyEnum, buildNotifyElement, 20);
}

function populateMedia(aElement) {
  identities = {};
  var mediaRoot = faves_coop.get(FLOCK_NS+'FavoritesRoot');  
  var myFilter = {flockType: 'photostream' };
  var mediaEnum = aggregateStreams(getContainedItems(mediaRoot, identities, myFilter));
  populateElement(aElement, mediaEnum, buildMediaElement, 20);
  
}

function populateFlock(aElement) {
  identities = {};
  var flockRoot = faves_coop.get(FLOCK_NS+'FavoritesRoot');  
  var myFilter = {flockType: 'feed' };
  var flockEnum = aggregateStreams(getContainedItems(flockRoot, identities, myFilter));
  populateElement(aElement, flockEnum, buildFlockElement, 20);
  
}

function buildNotifyElement(aCoopObj) {
  var hbox = document.createElement("hbox");
  var img = document.createElement("image");
  var label = document.createElement("label");
  
  img.setAttribute('src', aCoopObj.favicon);
  label.setAttribute('value', aCoopObj.name);
  
  hbox.appendChild (img);
  hbox.appendChild (label);
  hbox.setAttribute('onclick', 'openUILinkIn("' + aCoopObj.URL +'", "current")');
  
  return hbox;
}


function buildMediaElement(aCoopObj) {
  var hbox = document.createElement("hbox");
  var img = document.createElement("image");
 
  img.setAttribute('src', aCoopObj.thumbnail);
  img.setAttribute('tooltiptext', aCoopObj.name);
  img.setAttribute('id', aCoopObj.id());
 // img.setAttribute('onclick', 'openUILinkIn("flock://"+this.id, "current")');
   img.setAttribute('onclick', 'openUILinkIn("' + aCoopObj.URL + '", "current")');
  hbox.appendChild (img);
  
  return img;
}

function buildFlockElement(aCoopObj) {
  var hbox = document.createElement("hbox");
  var img = document.createElement("image");
  var label = document.createElement("label");
  var desc = document.createElement("label");
  
  img.setAttribute('src', aCoopObj.favicon);
  label.setAttribute('value', aCoopObj.name);
  desc.setAttribute('value', aCoopObj.description);
  
  hbox.appendChild (img);
  hbox.appendChild (label);
  hbox.setAttribute('onclick', 'openUILinkIn("' + aCoopObj.URL +'", "current")');
  
  return hbox;
}


function populateElement(aElement, aEnum, aBuilderMethod, aCount) {
  while (aElement.hasChildNodes()) 
   aElement.removeChild(aElement.firstChild); 
  var count = 0; 
  while (aEnum.hasMoreElements() && count <= aCount) {
   var item = aEnum.getNext();
   var element = aBuilderMethod(item); 
   aElement.appendChild(element);
   count++;
  } 
}

function getContainedItems(aFolder, identities, aFilter) {
  var result = new Array();
  var enum = aFolder.children.enumerate();
  while (enum.hasMoreElements()) {
    var obj = enum.getNext();
    if (!obj) continue;
    if (obj.isInstanceOf(faves_coop.Folder) ||
        obj.isInstanceOf(faves_coop.Person) ||
        obj.isInstanceOf(faves_coop.Account) ||
        obj.isInstanceOf(faves_coop.Identity))
      result = result.concat(getContainedItems(obj, identities, aFilter));
    var willAdd = true;
    for (rule in aFilter) {
      if (obj[rule] != aFilter[rule]) {
        willAdd = false;
        break;
      } 
    }
    if (willAdd) {
    	// identities[obj.id()] = obj.getParent();
    	result.push(obj.children.enumerate());
    }
  }
  return result;
}
