//
// BEGIN FLOCK GPL
// 
// Copyright Flock Inc. 2005-2007
// http://flock.com
// 
// This file may be used under the terms of of the
// GNU General Public License Version 2 or later (the "GPL"),
// http://www.gnu.org/licenses/gpl.html
// 
// Software distributed under the License is distributed on an "AS IS" basis,
// WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
// for the specific language governing rights and limitations under the
// License.
// 
// END FLOCK GPL
//

function $(aID) { return document.getElementById(aID); }
const XMLHTTPREQUEST_CONTRACTID     = '@mozilla.org/xmlextras/xmlhttprequest;1';

var firstRunWizard = {};

firstRunWizard.load = function() {
	dump("foofoo\n");
	this.mainWindow = window.arguments[0];
    this.updateCommands();
    this.loadCurrentIndex();
    this.wizardRemoveClose();
}

firstRunWizard.close = function() {
    if (this.mIndex != this.mWizards.length - 1) {
        if (!this.save()) return;
    }

    window.close();
}

firstRunWizard.unload = function() {
	dump ("foofoo: firstRunWizard is unloading...\n");
	this.mainWindow.firstRunOverlay.wizardFinished();
}


firstRunWizard.save = function() {
    for(var i = this.mIndex; i<this.mWizards.length; ++i) {
        if(this.mWizards[i].wizardSkip) {
            this.mWizards[i].wizardSkip();
        }
    }
    return true;
}

firstRunWizard.mWizards = new Array();
firstRunWizard.mIndex = 0;

firstRunWizard.finishCurrentPage = function() {
    if(firstRunWizard.mCommands.cmdNext.isEnabled()) {
        firstRunWizard.mCommands.cmdNext.exec();
    }
    else {
        firstRunWizard.close();
    }
}

firstRunWizard.getCookieString = function(aLocation) {
        var ios = Components.classes["@mozilla.org/network/io-service;1"]
            .getService(Components.interfaces.nsIIOService);
        var cservice = Components.classes["@mozilla.org/cookieService;1"]
            .getService().QueryInterface(Components.interfaces.nsICookieService);

        var uri = ios.newURI(aLocation, null, null);
        result = cservice.getCookieString(uri, null);
        dump(result + "\n");
        if (!result) result = "";
        return result;
}

function checkForSpecificCookie(aArrDomains, aArrCookies)
{
	var cookieString = null;
	var i = 0;
	while (!cookieString && i < aArrDomains.length)
	{
		cookieString = firstRunWizard.getCookieString(aArrDomains[i++]);
	}
	var foundCookie = false;
	for (i = 0; i < aArrCookies.length; i++)
	{
		if (cookieString.indexOf(aArrCookies[i]) != -1) foundCookie = true;
	}
	return foundCookie;
}

function checkForPref(aPrefName)
{
	var prefSVC = Components.classes['@mozilla.org/preferences-service;1']
                            .getService().QueryInterface(Components.interfaces.nsIPrefBranch);
	return (prefSVC.getPrefType(aPrefName) && prefSVC.getBoolPref(aPrefName));
}

firstRunWizard.callback = function(callbackUrl) {
	if (!checkForPref("browser.stats.sendAnonymous")) return;

	var req = Components.classes["@mozilla.org/xmlextras/xmlhttprequest;1"]
							.createInstance(Components.interfaces.nsIXMLHttpRequest);
	req.open('GET', callbackUrl, true);
	// JMC - Fire and forget, no onreadystatechange listener
	req.send(null);

}

firstRunWizard.buildStatsUrl = function(wizardName)
{
	return brandingUtilities.buildWebsiteUrl('browser', 'firstrun', wizardName, 'none');
}

//can you tell...
firstRunWizard.loadCurrentIndexPart2 = function() {
    var innerWindow = $("frame").contentWindow;
    var currentWizard = firstRunWizard.mWizards[firstRunWizard.mIndex];
    $("frame").setAttribute("src", currentWizard.wizardURL);
    $("frame").src = currentWizard.wizardURL;
    innerWindow.addEventListener('load', firstRunWizard.loadCurrentIndexPart3, false);
    
    // JMC - stats tracking
    if (currentWizard.statsURL) firstRunWizard.callback(currentWizard.statsURL);
}

firstRunWizard.wizardRemoveClose = function() {
    window.setTimeout(firstRunWizard.wizardRemoveClose,100);
    if(firstRunWizard.mInDelicatePhase) return;
    try {
        var innerWizard = $("frame").contentWindow.document.getElementsByTagName("wizard").item(0);
        if(innerWizard.onLastPage) {
            var cancel = innerWizard.getButton("cancel");
            cancel.setAttribute("hidden", true);
        }
    } catch(e) {}
}

firstRunWizard.wizardNext = function() {
}

//that this is a bit hacked...
firstRunWizard.loadCurrentIndexPart3 = function() {
    var innerWindow = $("frame").contentWindow;
    var currentWizard = firstRunWizard.mWizards[firstRunWizard.mIndex];
    innerWindow.arguments = currentWizard.wizardParameters;
    firstRunWizard.mInDelicatePhase = false;
    var innerWizard = $("frame").contentWindow.document.getElementsByTagName("wizard").item(0);
    if(innerWizard) {
//        innerWizard.addEventListener('wizardnext', firstRunWizard.wizardNext, false);
        //move around that cancel button
        var box = innerWizard.getButton("cancel").parentNode;
        box.insertBefore(innerWizard.getButton("cancel"), box.firstChild);
        var currentWizard = firstRunWizard.mWizards[firstRunWizard.mIndex];

        // update cancel with our own label
        if (currentWizard == WizardStart) {
          innerWizard.getButton("cancel").setAttribute("label", "Skip Setup");
        } else {
          innerWizard.getButton("cancel").setAttribute("label", 
            $("messages").getAttribute("skipMessage").replace(/%wizard/,currentWizard.wizardName));
        }
        innerWizard.getButton("finish").addEventListener('command', firstRunWizard.finishCurrentPage, false);

        innerWizard.getButton("finish").setAttribute("label", 
            $("messages").getAttribute("finishMessage"));

        // add our own event listeners.  may generalize this later
        if(firstRunWizard.mIndex==0) {
        }
        else {
            innerWizard.getButton("cancel")
                .addEventListener('command', firstRunWizard.finishCurrentPage, false);
        }
    }
    else {
        window.setTimeout("firstRunWizard.loadCurrentIndexPart3()", 50);
    }
}

firstRunWizard.loadCurrentIndex = function() {
    firstRunWizard.mInDelicatePhase = true;
    var innerWindow = $("frame").contentWindow;
    var currentWizard =  firstRunWizard.mWizards[firstRunWizard.mIndex];
    $("frame").setAttribute("src", "");
    $("frame").src = "";
    window.setTimeout("firstRunWizard.loadCurrentIndexPart2()", 50);
}

firstRunWizard.registerSubWizard = function(aSubWizard) {
    this.mWizards.push(aSubWizard);
}

firstRunWizard.advancePage = function(aOffset) {
    this.mIndex += aOffset;
    while(this.mIndex>0 && this.mIndex<this.mWizards.length) {
        if(!this.mWizards[this.mIndex].wizardEnabled) {
            if(this.mWizards[this.mIndex].wizardSkip) {
                this.mWizards[this.mIndex].wizardSkip();
            }
            this.advancePage(aOffset);
            return;
        }
        break;
    }
    firstRunWizard.loadCurrentIndex();
}

firstRunWizard.getWizardName = function(aID) {
    return $("wizardNames").getAttribute(aID);
}

firstRunWizard.getCheckboxLabel = function(aID) {
    return $("wizardCheckboxLabels").getAttribute(aID);
}

/////////////////////////////////////////////////////////////////////////////////////
// Command stuff
/////////////////////////////////////////////////////////////////////////////////////
firstRunWizard.mCommands = {};
firstRunWizard.mCommands.cmdNext = {
    isEnabled: function() {
        return (firstRunWizard.mIndex!=firstRunWizard.mWizards.length-1);
    },
    exec: function() {
        firstRunWizard.advancePage(1);
    },
};

firstRunWizard.mCommands.cmdPrev = {
    isEnabled: function() {
        return (firstRunWizard.mIndex!=0);
    },
    exec: function() {
        firstRunWizard.advancePage(-1);
    },
};

firstRunWizard.updateCommands = function() {
    var commands = $("firstRunWizardCommands");
    for(var i = 0;i<commands.childNodes.length;++i) {
        var command = commands.childNodes.item(i);
        var id = command.getAttribute("id");
        if(firstRunWizard.mCommands[id]) {
            if(firstRunWizard.mCommands[id].isEnabled()) {
                $(id).removeAttribute("disabled");
            }
            else {
                $(id).setAttribute("disabled", true);
            }
        }
    }
}

firstRunWizard.doCommand = function(aID) {
    firstRunWizard.mCommands[aID].exec();
    firstRunWizard.updateCommands();
}

/////////////////////////////////////////////////////////////////////////////////////
// Specific Pages
/////////////////////////////////////////////////////////////////////////////////////

var WizardStart = {
    wizardURL: "chrome://fbranding/content/firstRunWizardStart.xul",
    wizardName: firstRunWizard.getWizardName("start"),
    wizardLabel: firstRunWizard.getCheckboxLabel("start"),
    wizardEnabled: true,
    wizardParameters: [firstRunWizard],
    internal: true,
    statsURL: firstRunWizard.buildStatsUrl("firstRunStart"),
}


var FlashFirstRun = {
    wizardURL: "chrome://mozapps/content/plugins/pluginInstallerWizard.xul",
    wizardParameters: null,
    wizardName: firstRunWizard.getWizardName("flash"),
    wizardLabel: firstRunWizard.getCheckboxLabel("flash"),
    wizardEnabled: false,
    internal: true,
    statsURL: firstRunWizard.buildStatsUrl("flashSetup"),
    init: function() {
        var flash = "application/x-shockwave-flash";
        var missingPluginsArray = new Object;
        var pluginInfo = {mimetype: flash, pluginsPage: "about:blank"};
        missingPluginsArray[pluginInfo.mimetype] = pluginInfo;
        this.wizardParameters = [{plugins: missingPluginsArray, tab: null}];
        if(!this.hasFlash()) {
            this.wizardEnabled = true;
        }
    },
    hasFlash: function() {
       	if(navigator.plugins && navigator.plugins.length 
				&& (navigator.plugins["Shockwave Flash"]) || 
	        		navigator.plugins["Shockwave Flash 2.0"]) return true;

	    if(navigator.mimeTypes && navigator.mimeTypes.length
	        && navigator.mimeTypes['application/x-shockwave-flash']
			&& navigator.mimeTypes['application/x-shockwave-flash'].enabledPlugin) return true;

		return false;
    },
}

FlashFirstRun.init();

var PhotoFirstRun = {
    wizardURL: "chrome://browser/content/flock/photo/photoAccountWizard.xul",
    wizardParameters: [],
    wizardName: firstRunWizard.getWizardName("photo"),
    wizardLabel: firstRunWizard.getCheckboxLabel("photo"),
    wizardEnabled: false,
    statsURL: firstRunWizard.buildStatsUrl("photoSetup"),
    init: function() {
        var params = {};
        params["autoImport"] = true;
        this.wizardParameters[0] = params;
    },
}
PhotoFirstRun.init();


var FlickrFirstRun = {
    wizardURL: "chrome://browser/content/flock/photo/photoAccountWizard.xul",
    wizardParameters: ["flickr"],
    wizardName: firstRunWizard.getWizardName("flickr"),
    wizardLabel: firstRunWizard.getCheckboxLabel("flickr"),
    wizardEnabled: false,
    statsURL: firstRunWizard.buildStatsUrl("photoFlickrSetup"),
    init: function() {
		if (checkForSpecificCookie(["http://flickr.com", "http://www.flickr.com"], 
									['cookie_epass', 'cookie_session'])
			|| !checkForPref("browser.didImport"))
        {
            this.wizardEnabled = true;
            PhotoFirstRun.wizardEnabled = true;
        }
    },
}

FlickrFirstRun.init();

var PhotobucketFirstRun = {
    wizardURL: "chrome://browser/content/flock/photo/photoAccountWizard.xul",
    wizardParameters: ["photobucket"],
    wizardName: firstRunWizard.getWizardName("photobucket"),
    wizardLabel: firstRunWizard.getCheckboxLabel("photobucket"),
    wizardEnabled: false,
    statsURL: firstRunWizard.buildStatsUrl("photoPBSetup"),
    init: function() {
		if (checkForSpecificCookie(["http://photobucket.com"], 
									['pbusername', 'utm'])
									|| checkForPref('flock.firstrun.showPB')
									|| !checkForPref("browser.didImport"))
        {
            this.wizardEnabled = true;
            PhotoFirstRun.wizardEnabled = true;
        }
    },
}

PhotobucketFirstRun.init();

var WizardEnd = {
    wizardURL: "chrome://fbranding/content/firstRunWizardEnd.xul",
    wizardParameters: null,
    wizardName: "Flock Wizard End",
    wizardEnabled: true,
    internal: true,
    statsURL: firstRunWizard.buildStatsUrl("firstRunEnd"),
    wizardParameters: [firstRunWizard],
}



var BlogFirstRun = {
    wizardURL: "chrome://browser/content/flock/blog/blogAccountWizard.xul",
    wizardParameters: null,
    wizardName: firstRunWizard.getWizardName("blog"),
    wizardLabel: firstRunWizard.getCheckboxLabel("blog"),
    wizardEnabled: false,
    statsURL: firstRunWizard.buildStatsUrl("blogSetup"),
	init: function() {
		this.wizardEnabled = (checkForSpecificCookie(["http://wordpress.com"], ['wp_user', 'wp_pass', 'wordpressloggedin'])
				|| checkForSpecificCookie(["http://wordpress.com"], ['wp_user', 'wp_pass', 'wordpressloggedin'])
				|| checkForSpecificCookie(["http://livejournal.com"], ['ljloggedin'])
				|| checkForSpecificCookie(["http://blogger.com"], ['B1|'])
				|| checkForSpecificCookie(["http://typepad.com"], ['session_id', '__utma'])
				|| !checkForPref("browser.didImport"));
    },
}

BlogFirstRun.init();

var FavoritesFirstRun = {
    wizardURL: "chrome://browser/content/flock/favorites/favoritesSharing.xul",
    wizardParameters: ['firstrun'],
    wizardName: firstRunWizard.getWizardName("favorites"),
    wizardLabel: firstRunWizard.getCheckboxLabel("favorites"),
    wizardEnabled: false,
    statsURL: firstRunWizard.buildStatsUrl("favoritesSetup"),
	init: function() {
		this.wizardEnabled = (checkForSpecificCookie(["http://del.icio.us"], ['_user', '_items'])
				|| checkForSpecificCookie(["http://shadows.com"], ['RememberLogin', '.ASPXAUTH' , '__utma'])
				|| !checkForPref("browser.didImport"));
		},
}

FavoritesFirstRun.init();
/* JMC: Takin this out, BUG #4464
var FeedFirstRun = {
    wizardURL: "chrome://browser/content/flock/feeds/feedFirstRun.xul",
    wizardParameters: null,
    wizardName: firstRunWizard.getWizardName("feed"),
    wizardLabel: firstRunWizard.getCheckboxLabel("feed"),
    wizardEnabled: true,
    wizardSkip: function() {
        // load first feed no matter what
        var key = "feeds.bundles.urls_0";
        var url = $("strings").getString(key);
        feedUtils.loadFeedsFromLocalOPML(url);
    },
}
*/

/*
JMC: Takin this out, BUG #4463
var SearchFirstRun = {
    wizardURL: "chrome://browser/content/flock/search/searchSetupWizard.xul",
    wizardParameters: null,
    wizardName: firstRunWizard.getWizardName("search"),
    wizardLabel: firstRunWizard.getCheckboxLabel("search"),
    wizardEnabled: true,
}
*/

firstRunWizard.registerSubWizard(WizardStart);
//firstRunWizard.registerSubWizard(FlickrFirstRun);
//firstRunWizard.registerSubWizard(PhotobucketFirstRun);
//firstRunWizard.registerSubWizard(SearchFirstRun);
firstRunWizard.registerSubWizard(PhotoFirstRun);
firstRunWizard.registerSubWizard(BlogFirstRun);
firstRunWizard.registerSubWizard(FavoritesFirstRun);
//firstRunWizard.registerSubWizard(FeedFirstRun);
firstRunWizard.registerSubWizard(FlashFirstRun);
firstRunWizard.registerSubWizard(WizardEnd);
