//
// BEGIN FLOCK GPL
// 
// Copyright Flock Inc. 2005-2007
// http://flock.com
// 
// This file may be used under the terms of of the
// GNU General Public License Version 2 or later (the "GPL"),
// http://www.gnu.org/licenses/gpl.html
// 
// Software distributed under the License is distributed on an "AS IS" basis,
// WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
// for the specific language governing rights and limitations under the
// License.
// 
// END FLOCK GPL
//

const FLOCK_DEFAULT_FEEDS_OPML = "chrome://flock/locale/feeds/opml/default.opml";

var firstRunOverlay = {};
firstRunOverlay.launchWizard = function() {
	dump("foofoo: top is " + top + "\n");
    window.openDialog("chrome://fbranding/content/firstRunWizard.xul", 
        "FlockFirstRunWizard", "chrome,all,centerscreen,titlebar,dependent,resizable=no,alwaysRaised", top);
}

firstRunOverlay.launchSubWizard = function(aType) {
	switch (aType) {
		case 'photo':
			window.openDialog("chrome://browser/content/flock/photo/photoAccountWizard.xul",
		 "PhotoAccountWizard", "all,centerscreen,titlebar,dependent,resizable=no,alwaysRaised");
		break;
		case 'blog':
			window.openDialog("chrome://browser/content/flock/blog/blogAccountWizard.xul",
			 "accountWizard", "all,centerscreen,titlebar,dependent,resizable=no,alwaysRaised");
		break;
		case 'favorites':
			window.openDialog('chrome://browser/content/flock/favorites/favoritesSharing.xul',
			 'Favorites Sharing', 'all,centerscreen,titlebar,dependent,resizable=no,alwaysRaised');
		break;
	}
}

firstRunOverlay.wizardFinished = function() {
	dump ("foofoo: wizard has finished. Gonna reload tabs\n");
	if (this.firstRunUrl) gBrowser.addTab(this.firstRunUrl);
	gBrowser.mCurrentBrowser.loadURI(gBrowser.mCurrentBrowser.currentURI.spec + "?");
	
	// JMC - Time for A/B test
	if (flock_getBoolPref('browser.stats.sendAnonymous')
	&& !flock_getCharPref('flock.photo.preferredServices')
	&& (flock_getIntPref('flock.first_run.date') % 2)) {
		flock_topbarSelectById('flock_PhotoBrowseTopbarBroadcaster', true);
		var req = Components.classes["@mozilla.org/xmlextras/xmlhttprequest;1"]
							.createInstance(Components.interfaces.nsIXMLHttpRequest);
		req.open('GET', brandingUtilities.buildWebsiteUrl('browser', 'firstrun', 'photobarOpened', 'none'), true);
		req.send(null);
	}
}


top.addEventListener("load", function() {
    var firstRunForBrowser = flock.firstrun.isFirstRunForComponent("browser_startup");
    var firstRunForFeeds = flock.firstrun.isFirstRunForComponent("feeds_startup");
    if(firstRunForBrowser) {
        flock_setCharPref("flock.first_run.bigDate", Date.now());
        // YOSH BROKE OPML, YOU MONKEY
        try {
         var aus = Components.classes["@mozilla.org/updates/update-service;1"]
             .getService(Components.interfaces.nsIApplicationUpdateService);
        aus.startupPing();
        } catch (e) {
         dump ("YOSH BROKE OPML BY NOT ERROR CHECKING, SILLY MONKEY!!!\n");
         dump (e); 
        }
    }
	// JMC: Just adding default OPMLs since we don't show the wizard
	if (firstRunForFeeds) {
		/*
	    var nameStart = "feeds.bundles.names_";
	    var urlStart = "feeds.bundles.urls_";
	    var count = 0;
	    for(;;) {
	        var nameKey = nameStart + count;
	        var urlKey = urlStart + count;
	        try {
	            var name = $("strings").getString(nameKey);
	            var url = $("strings").getString(urlKey);
	        	feedUtils.loadFeedsFromLocalOPML(url);
			} catch(e) {
	            break;
	        }
		}
		*/
		feedUtils.loadFeedsFromLocalOPML(FLOCK_DEFAULT_FEEDS_OPML);
	}

/*
    if(firstRunForBrowser || firstRunForFeeds) {
        var firstRunUrl = flock_getCharPref('flock.first_run.url');
        if (firstRunUrl) {
			firstRunOverlay.firstRunUrl = firstRunUrl;
		}
		// var firstRunPB = flock_getBoolPref('flock.firstrun.showPB');
		// if (firstRunPB)	flock_topbarSelectById('flock_PhotoBrowseTopbarBroadcaster', true);
        //launch the first run wizard
		//JMC: Only launch if we determine that there's something to do...
		// And only launch the metawizard if there's more than one to run...
		if (!hasFlash() || needsSetup()) {
			if (needsSetup() == 1) {
				if (needsPhotoSetup()) {
					if (firstRunUrl) gBrowser.addTab(firstRunUrl);
					window.setTimeout("firstRunOverlay.launchSubWizard('photo');",0);
				} else if (needsBloggingSetup()) {
					if (firstRunUrl) gBrowser.addTab(firstRunUrl);
					window.setTimeout("firstRunOverlay.launchSubWizard('blog');",0);
				} else if (needsFavoritesSetup()) {
					if (firstRunUrl) gBrowser.addTab(firstRunUrl);
					window.setTimeout("firstRunOverlay.launchSubWizard('favorites');",0);
				} else {
					// JMC - Edge case, needs flash and doesn't need anything else
		        	window.setTimeout("firstRunOverlay.launchWizard();",0);
				}
			} else {
        		window.setTimeout("firstRunOverlay.launchWizard();",0);
			}
		}
    }
*/
    initializeBranding();
}, false);

function hasFlash() {
	if(navigator.plugins && navigator.plugins.length 
			&& (navigator.plugins["Shockwave Flash"]) || 
        		navigator.plugins["Shockwave Flash 2.0"]) return true;

    if(navigator.mimeTypes && navigator.mimeTypes.length
        && navigator.mimeTypes['application/x-shockwave-flash']
		&& navigator.mimeTypes['application/x-shockwave-flash'].enabledPlugin) return true;
        
	return false;
}

function needsSetup() {
	dump("Checking if we need setup...\n");
	dump ("If there's no cookies, we'll set up everything\n");
	if (!flock_getBoolPref("browser.didImport")) return 2; // Run full wizard
	
	var i = 0;
	if (needsPhotoSetup()) i++;
	if (needsBloggingSetup()) i++;
	if (needsFavoritesSetup()) i++;
	if (!hasFlash()) i++;

	return i;
}

function needsPhotoSetup() {
	if (checkForSpecificCookie(["http://flickr.com", "http://www.flickr.com"], 
								['cookie_epass', 'cookie_session'])
		|| checkForSpecificCookie(["http://photobucket.com"], ['pbusername', 'utm'])
		|| checkForPref('flock.firstrun.showPB')) return true;
	return false;
}

function needsBloggingSetup() {
	if (checkForSpecificCookie(["http://wordpress.com"], ['wp_user', 'wp_pass', 'wordpressloggedin'])
		|| checkForSpecificCookie(["http://wordpress.com"], ['wp_user', 'wp_pass', 'wordpressloggedin'])
		|| checkForSpecificCookie(["http://livejournal.com"], ['ljloggedin'])
		|| checkForSpecificCookie(["http://blogger.com"], ['B1|'])
		|| checkForSpecificCookie(["http://typepad.com"], ['session_id', '__utma'])) return true;
	return false;
}

function needsFavoritesSetup() {
	if (checkForSpecificCookie(["http://del.icio.us"], ['_user', '_items'])
		|| checkForSpecificCookie(["http://shadows.com"], ['RememberLogin', '__utma', '.ASPXAUTH'])) return true;
	return false;
}

function getCookieString(aLocation) {
        var ios = Components.classes["@mozilla.org/network/io-service;1"]
            .getService(Components.interfaces.nsIIOService);
        var cservice = Components.classes["@mozilla.org/cookieService;1"]
            .getService().QueryInterface(Components.interfaces.nsICookieService);
        var uri = ios.newURI(aLocation, null, null);
        result = cservice.getCookieString(uri, null);
        dump(result + "\n");
        if (!result) result = "";
        return result;
}

function checkForSpecificCookie(aArrDomains, aArrCookies)
{
	var cookieString = null;
	var i = 0;
	while (!cookieString && i < aArrDomains.length)
	{
		cookieString = getCookieString(aArrDomains[i++]);
	}
	var foundCookie = false;
	for (i = 0; i < aArrCookies.length; i++)
	{
		if (cookieString.indexOf(aArrCookies[i]) != -1) foundCookie = true;
	}
	return foundCookie;
}

function checkForPref(aPrefName)
{
	var prefSVC = Components.classes['@mozilla.org/preferences-service;1']
                            .getService().QueryInterface(Components.interfaces.nsIPrefBranch);
	return (prefSVC.getPrefType(aPrefName) && prefSVC.getBoolPref(aPrefName));
}

function revertToOriginalToolbar() {
    var rdfService = Components.classes["@mozilla.org/rdf/rdf-service;1"].
        getService(Components.interfaces.nsIRDFService);
    var ds = rdfService.GetDataSource("rdf:local-store");
    var node = rdfService.GetResource("chrome://browser/content/browser.xul#nav-bar");
    var props=ds.ArcLabelsIn(node);
    while(props.hasMoreElements()){
        var prop=props.getNext();
        var source=ds.GetSource(prop,node,true);
        ds.Unassert(source,prop,node);
    }
}

function checkIfBuzzardUpgrade() {
    var prefs = Components.classes["@mozilla.org/preferences-service;1"]
        .getService(Components.interfaces.nsIPrefBranch);

    // LOGIC: we only are doing a buzzard upgrade if the key doesn't exist

    try {
        var browserStartupKey = "flock.firstrun.components.browser_startup.completed";
        var feedsStartupKey = "flock.firstrun.components.feeds_startup.completed";
        var browserKeyExists = prefs.getBoolPref(browserStartupKey);
        prefs.getBoolPref(feedsStartupKey);
    } catch (e) { 
	if(browserKeyExists) {
            revertToOriginalToolbar();            //Buzzard upgrade if the browser first run ran, but feeds first run has not

	}
    }
}

checkIfBuzzardUpgrade();
